--[[
TODO:
1) Reset Button
2) Mac'Aree dudes
3) Make it not look like shit
4) Add in different coloring for rares that drop shit

]]

local f = CreateFrame("FRAME",nil,UIParent)

f:SetMovable(true)
f:EnableMouse(true)
f:SetClampedToScreen(true)
f:RegisterForDrag("LeftButton")
f:SetScript("OnDragStart", f.StartMoving)
f:SetScript("OnDragStop", f.StopMovingOrSizing)

local Kbosses = {"Sister Subversia", "Khazaduum", "Vagath the Betrayed", "Commander Endaxis", "Commander Vecaya", "Commander Sathrenael", "Imp Mother Laglath", "Seigemaster Voraan", "Talestra the Vile", "Tereck the Selector", "Tar Spitter", "Naroua"}
local KquestIDs = {48565, 48561, 48629, 48564, 48563, 48562, 48666, 48627, 48628, 48664, 48665, 48667}

local Abosses = {"Houndmaster Kerrax", "Puscilla", "Mother Rosula", "Chief Alchemist Munculus", "Inquisitor Vethroz", "Gar'zoth", "Admiral Rel'var", "All-Seer Xanarian", "Blistermaw" , "Vrax'thul" , "Ven'orn", "Varga", "Wrath-Lord Yarez", "WorldSplitter Skuul", "Lieutenant Xakaar", "The Many-Faced Devourer", "Mistress Il'thendra", "Doomcaster Suprax", "Squadron Commander Vishax", "Void Warden Valsuran", "Commander Texlaz", "Rezira the Seer" ,"Watcher Aival"}
local AquestIDs = {48821, 48809, 48970, 48865, 48815, 49241, 48817, 48818, 49183, 48810, 48811, 48812, 48814, 48820, 48813, 48966, 49240, 48968, 48967, 48824, 48816, 48971, 48822}

local Mbosses = {}
local MquestIDs = {}

local clicked = ""

function makeButton(boss, f, x, y)
	local goButton = CreateFrame("button",nil,f,"UIPanelButtonTemplate")
	goButton:SetPoint("TOPRIGHT",x+50,y+10)
	goButton:SetText("Check")
	goButton:SetHeight(30)
	goButton:SetWidth(50)
	goButton:RegisterEvent("LFG_LIST_SEARCH_FAILED")
	
	goButton:SetScript("OnClick", function()
		clicked = boss
		local result = f:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		local nameMatch = false
		C_LFGList.Search(6, LFGListSearchPanel_ParseSearchTerms(boss))
		
		local searchCount, searchResults = C_LFGList.GetSearchResults()
		
		if(searchCount > 0) then
			for i, v in pairs(searchResults) do
				local name = select(3, C_LFGList.GetSearchResultInfo(v))
				if(string.find(string.lower(name), string.lower(boss))) then
					nameMatch = true
				end
			end
			
			
			if(nameMatch) then
				--print(Kbosses[index].." "..searchCount)
				--print(searchResults)
				result:SetText("Yes")
				goButton:Hide()
				result:SetPoint("TOPRIGHT", x+50, y)
				result:SetTextColor(.537, .941, .667, 1)
			end	
		else
			goButton:SetText("Re-try")	
		end
	end)
	goButton:SetScript("OnEvent", function(__, event,...)
		if(clicked == boss)then 
			goButton:SetText("Failed")
		end
	end)
	
end

function makeList(bosses, f, questIDs, zone)
	SetMapByID(zone)
	local quests = C_TaskQuest.GetQuestsForPlayerByMapID(zone)
	
	
		
	 for i = 1,#bosses do
		local bossName = f:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		bossName:SetText(bosses[i])
		local x = -100
		local y = -40
		if(i < 14) then
			x = x - 300
			y = y - i*30
		else
			y = y-(i-13)*30
		end
		bossName:SetPoint("TOPRIGHT", x, y)
	
		local result = f:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		
		if(IsQuestFlaggedCompleted(questIDs[i])) then
			result:SetTextColor(.537, .812, .941, 1)
			result:SetText("Killed")
			result:SetPoint("TOPRIGHT", x+50, y)
		else
			for j, v in pairs (quests) do
				local questName = select(1, C_TaskQuest.GetQuestInfoByQuestID(v.questId))
				if(string.lower(questName) == string.lower(bosses[i])) then
					result:SetTextColor(.537, .812, .941, 1)
					result:SetText("WQ")
					result:SetPoint("TOPRIGHT", x+50, y)
					break
				end	
			end
			if(not result:GetText()) then
				makeButton(bosses[i],f,x,y)
			end	
		end
	 end
 end


f:SetFrameStrata("HIGH")
f:SetSize(600,550)

f:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }})
f:SetBackdropColor(0,0,0,1)

--brief text
local texta = f:CreateFontString(nil, "OVERLAY", "GameFontNormal")
local textb = f:CreateFontString(nil, "OVERLAY", "GameFontNormal")
texta:SetText("You will have to click twice to find a group.  Will say re-try if it cannot find a group,")
textb:SetText("or failed if the search function fails.  For best results, wait ~2s between clicks.")
texta:SetPoint("TOPLEFT", 10, -450)
textb:SetPoint("TOPLEFT", 10, -470)

--Buttons
local fKrokuun = CreateFrame("FRAME", nil, f)
fKrokuun:SetAllPoints(f)
local fAntoran = CreateFrame("FRAME", nil, f)
fAntoran:SetAllPoints(f)
local fMacaree = CreateFrame("FRAME", nil, f)
fMacaree:SetAllPoints(f)

local KrokButton = CreateFrame("button",nil,f,"UIPanelButtonTemplate")
	KrokButton:SetPoint("TOPLEFT",10,-10)
	KrokButton:SetText("Krokuun")
	KrokButton:SetHeight(30)
	KrokButton:SetWidth(186)
	KrokButton:SetScript("OnClick", function()
		fAntoran:Hide()
		fMacaree:Hide()
		fKrokuun:Show()
	end)
	
local AntButton = CreateFrame("button",nil,f,"UIPanelButtonTemplate")
	AntButton:SetPoint("TOPLEFT",206,-10)
	AntButton:SetText("Antorus Wastes")
	AntButton:SetHeight(30)
	AntButton:SetWidth(187)
	AntButton:SetScript("OnClick", function()
		fAntoran:Show()
		fMacaree:Hide()
		fKrokuun:Hide()
	end)
	
local MacButton = CreateFrame("button",nil,f,"UIPanelButtonTemplate")
	MacButton:SetPoint("TOPLEFT",403,-10)
	MacButton:SetText("Mac'Aree")
	MacButton:SetHeight(30)
	MacButton:SetWidth(186)
	MacButton:SetScript("OnClick", function()
		fAntoran:Hide()
		fMacaree:Show()
		fKrokuun:Hide()
	end)
	
--Generate Lists
makeList(Kbosses, fKrokuun, KquestIDs, 1135)
makeList(Abosses, fAntoran, AquestIDs, 1171)
makeList(Mbosses, fMacaree, MquestIDs, 1170)
 
 f:SetPoint("CENTER",0,0)
 
 --Set up slash command
 SLASH_AR1 = "/ar"
 SlashCmdList["AR"] = function ()
	if(f:IsShown()) then
		f:Hide()
	else
		f:Show()
	end
 end
 
 --Close Button
 local closeButton = CreateFrame("button",nil,f,"UIPanelButtonTemplate")
	closeButton:SetPoint("BOTTOMRIGHT",-10,10)
	closeButton:SetText("Close")
	closeButton:SetHeight(30)
	closeButton:SetWidth(285)
	closeButton:SetScript("OnClick", function()
		f:Hide()
	end)
	
--reset Button	
 local resetButton = CreateFrame("button",nil,f,"UIPanelButtonTemplate")
	resetButton:SetPoint("BOTTOMLEFT",10,10)
	resetButton:SetText("Reset - NYI")
	resetButton:SetHeight(30)
	resetButton:SetWidth(285)
	resetButton:SetScript("OnClick", function()
		--do stuff
	end)
	
fAntoran:Hide()
fMacaree:Hide()
fKrokuun:Show()
f:Hide()